#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <sys/socket.h>

int main(int argc, char **argv, char **envp)
{
  int fd, portno, i;
  struct hostent *server;
  struct sockaddr_in serv_addr;
  char **new_argv;
  
  server = gethostbyname(argv[1]);
  portno = atoi(argv[2]);
                
  memset(&serv_addr, 0, sizeof(serv_addr));
  serv_addr.sin_family = AF_INET;
  memcpy(&serv_addr.sin_addr.s_addr, server->h_addr, server->h_length);
  serv_addr.sin_port = htons(portno);
  
  fd = socket(PF_INET, SOCK_STREAM, getprotobyname("tcp")->p_proto);
  if (connect(fd, (const struct sockaddr *)&serv_addr, sizeof(serv_addr))) {
    perror(strerror(errno));
  } else {
    new_argv = (char **)malloc(sizeof(char*) * (argc - 3 + 1));
    for (i = 3; i < argc; i++)
      new_argv[i - 3] = argv[i];
    new_argv[i - 3] = NULL;

    dup2(fd, 0);
    dup2(fd, 1);

    execve(argv[3], new_argv, envp);
    perror(strerror(errno));
  }

  return 1;
}
